Mercurial > emacs
view lib-src/rcs2log @ 105341:2a8a3a69c1c7
2009-10-01 Carsten Dominik <carsten.dominik@gmail.com>
* org.el (org-set-tags-to): New command.
* org-latex.el (org-export-latex-set-initial-vars): Also check in
the plist.
* org.el (org-additional-option-like-keywords): Add LATEX_CLASS
keyword.
* org-exp.el (org-infile-export-plist): Add LATEX_CLASS keyword.
2009-10-01 Carsten Dominik <carsten.dominik@gmail.com>
* org-inlinetask.el (org-inlinetask-export): Option removed.
(org-inlinetask-export-handler): Better export.
* org-xoxo.el (org-export-xoxo-final-hook): New hook.
(org-export-as-xoxo): Run the new hook.
* org-html.el (org-export-html-final-hook): New hook.
(org-export-as-html): Run the new hook.
* org-docbook.el (org-export-docbook-final-hook): New hook.
(org-export-as-docbook): Run the new hook.
* org-ascii.el (org-export-ascii-final-hook): New hook.
(org-export-as-ascii): Run the new hook.
* org-latex.el (org-export-latex-treat-sub-super-char): Allow a
space character as the character before the ^/_.
(org-export-latex-final-hook): New hook.
(org-export-as-latex): Run `org-export-latex-final-hook'.
2009-10-01 Carsten Dominik <carsten.dominik@gmail.com>
* org-macs.el (org-if-unprotected-at): Fix docstring.
* org-agenda.el (org-agenda-change-all-lines): Handle invisible
text in the prefix (if category is a link).
* org-latex.el (org-export-latex-preprocess): Deal properly with
empty lines in verse environments.
* org.el (org-format-latex-header): Inline fullpage.sty.
* org-footnote.el (org-footnote-create-definition): Reveal context
to add a new footnote definition.
* org.el (org-ctrl-c-ctrl-c): Pass prefix arg to
org-table-recalculate when cursor is in TBLFM line.
* org-list.el (org-renumber-ordered-list): Fix cursor position
when bullet length has changed.
2009-10-01 Carsten Dominik <carsten.dominik@gmail.com>
* org.el (org-format-latex): Mention `org-format-latex-options' in
the docstring.
2009-10-01 Carsten Dominik <carsten.dominik@gmail.com>
* org.el (org-agenda-get): New function.
* org-agenda.el (org-agenda-post-command-hook): No longer move
point away from end of line.
(org-agenda-add-entry-text, org-agenda-collect-markers)
(org-finalize-agenda, org-agenda-mark-clocking-task)
(org-agenda-dim-blocked-tasks, org-agenda-entry-text-show-here)
(org-agenda-entry-text-show, org-agenda-highlight-todo)
(org-agenda-compare-effort, org-agenda-filter-apply)
(org-agenda-later, org-agenda-change-time-span)
(org-agenda-post-command-hook, org-agenda-show-priority)
(org-agenda-show-tags, org-agenda-goto, org-agenda-kill)
(org-agenda-archive, org-agenda-archive-to-archive-sibling)
(org-remove-subtree-entries-from-agenda, org-agenda-refile)
(org-agenda-open-link, org-agenda-copy-local-variable)
(org-agenda-switch-to, org-agenda-check-no-diary)
(org-agenda-tree-to-indirect-buffer, org-agenda-todo)
(org-agenda-add-note, org-agenda-change-all-lines)
(org-agenda-priority, org-agenda-set-tags)
(org-agenda-set-property, org-agenda-set-effort)
(org-agenda-toggle-archive-tag, org-agenda-date-later)
(org-agenda-show-new-time, org-agenda-date-prompt)
(org-agenda-schedule, org-agenda-deadline, org-agenda-action)
(org-agenda-clock-in, org-agenda-bulk-mark)
(org-agenda-bulk-unmark, org-agenda-show-the-flagging-note): Use
`org-get-at-bol'.
* org-colview.el (org-columns-display-here)
(org-columns-edit-allowed, org-agenda-columns): Use
`org-get-at-bol'.
2009-10-01 Carsten Dominik <carsten.dominik@gmail.com>
* org.el (org-special-ctrl-a/e): Improve documentation and
customize type.
(org-end-of-line): Don't jump to after the ellipsis.
(org-mode-map): Bind <home> and <end> as well.
2009-10-01 Carsten Dominik <carsten.dominik@gmail.com>
* org.el (org-fontify-meta-lines-and-blocks): Treat lines with a
space after #+ as comments.
(org-open-at-point): Run `org-follow-link-hook' always.
* org-latex.el (org-export-latex-emph-format): Use better commands
to insert special characters in verbatim snippets.
2009-10-01 Carsten Dominik <carsten.dominik@gmail.com>
* org-faces.el (org-copy-face): New function. Use it to create
various faces formerly created by using `copy-face'.
* org-agenda.el (org-prepare-agenda): Don't officially mark this
window dedicated.
(org-agenda-quit): Kill the frame containing the agenda window if
that frame was created for the agenda.
2009-10-01 Carsten Dominik <carsten.dominik@gmail.com>
* org-agenda.el (org-agenda-date-prompt): Mark the changed time
stamp in the agenda.
2009-10-01 Carsten Dominik <carsten.dominik@gmail.com>
* org-agenda.el (org-prepare-agenda): Reset
`org-drawers-for-agenda'.
(org-prepare-agenda): Uniquify list of drawers.
* org.el (org-complex-heading-regexp-format): New variable.
(org-set-regexps-and-options): Define
`org-complex-heading-regexp-format'.
(org-drawers-for-agenda): New variable.
(org-map-entries): Bind `org-drawers-for-agenda'.
(org-prepare-agenda-buffers): Add to `org-drawers-for-agenda'.
* org-remember.el (org-go-to-remember-target)
(org-remember-handler): Use `org-complex-heading-regexp-format'.
2009-10-01 Carsten Dominik <carsten.dominik@gmail.com>
* org-agenda.el (org-agenda-highlight-todo): Fix text property
problem.
* org.el (org-on-heading-p, org-at-heading-p): Make sure these are
always with `invisible-ok'.
(org-store-link): No error when there is nothing to link to in the
agenda.
* org-list.el (org-update-checkbox-count): Insert changed cookie
before the old, to avoid problems with invisibility at the end of
the line.
(org-update-checkbox-count): Insert changed cookie before the old,
to avoid problems with invisibility at the end of the line.
* org.el (org-sort-entries-or-items): Include the final newline.
(org-fontify-meta-lines-and-blocks): Add indented dynamic block
lines for fontification.
(org-dblock-start-re, org-dblock-end-re): Allow indentation.
(org-prepare-dblock): Store the current indentation of the BEGIN
line.
(org-update-dblock): Apply the indentation of the begin line to
the rest of the block.
(org-ctrl-c-ctrl-c): Also find indented dblock lines.
(org-startup-folded): New allowed value `showeverything'.
(org-startup-options): Add STARTUP keyword `showeverything'.
(org-set-startup-visibility): Respect value `showeverything' in
org-startup-folded.
2009-10-01 Carsten Dominik <carsten.dominik@gmail.com>
* org.el (org-closest-date): Fix issue with past preference.
* org-archive.el (org-archive-set-tag)
(org-archive-subtree-default): New commands.
* org-clock.el (org-clock-clocktable-default-properties): New
option.
(org-clock-report): Use
`org-clock-clocktable-default-properties'.
2009-10-01 Carsten Dominik <carsten.dominik@gmail.com>
* org.el (org-iswitchb-completing-read): Fix typo.
* org-crypt.el: New file.
* org.el: Add an entry for org-crypt.
2009-10-01 Carsten Dominik <carsten.dominik@gmail.com>
* org-agenda.el (org-agenda-menu): Reorganize the menu for more
consistency.
(org-batch-store-agenda-views): New function.
(org-agenda-title-append): Define variable.
(org-write-agenda): New export to Org files.
(org-agenda-get-some-entry-text): New arguments INDENT and KEEP.
(org-agenda): Allow to keep the restricted file list if a special
variable is bound to t.
(org-agenda): Define a special agenda view for working on flagged
entries.
(org-agenda-get-restriction-and-command): List the new agenda
view.
(org-agenda-show-the-flagging-note): New command.
(org-agenda-mode-map): New key `?' for looking at the flagging
note.
* org.el (org-autoload): Autoload org-mobile.el.
(org-org-menu): Add menu commands for MobileOrg in the Org menu.
* org-mobile.el: New file.
* org-id.el (org-id-get): Fix bug with forcing ID on an item.
2009-10-01 Carsten Dominik <carsten.dominik@gmail.com>
* org-table.el (orgtbl-line-start-regexp): Match also TBLNAME
statements.
(org-table-get-remote-range): Match indented #+TBLNAME
statements.
* org.el (org-convert-to-odd-levels)
(org-convert-to-oddeven-levels): Work also correctly if the file
is in outline-mode.
2009-10-01 Carsten Dominik <carsten.dominik@gmail.com>
* org.el (org-store-link): When in agenda buffer, link to
referenced entry.
(org-add-planning-info): Remove spaces at eol.
* org-macs.el (org-with-point-at): Add a `lisp-indent-function'
property.
2009-10-01 Carsten Dominik <carsten.dominik@gmail.com>
* org-latex.el (org-export-latex-first-lines): Fix problem with
LaTeX export of first line and selected subtree.
* org.el (org-shifttab): Interpret arg differently when using only
odd levels.
2009-10-01 Bastien Guerry <bzg@altern.org>
* org.el (org-check-agenda-file): Use a more explicit message
2009-10-01 Carsten Dominik <carsten.dominik@gmail.com>
* org-exp.el (org-export-remove-special-table-lines): Don't remove
normal lines.
2009-10-01 Bastien Guerry <bzg@altern.org>
* org.el (org-offer-links-in-entry): Don't use "Select link" as a
prompt in the temporary window.
* org-agenda.el (org-agenda-bulk-mark): Use a slightly soberer
prefix for marked entries in the agenda view.
2009-10-01 Andreas Burtzlaff <andy13@gmx.net> (tiny change)
* org.el (outline-end-of-subtree): Bugfix: advise this function in
a way that prevents any trailing character from being displayed.
2009-10-01 Carsten Dominik <carsten.dominik@gmail.com>
* org-agenda.el (org-agenda-menu): Fix bugs in the bulk action
menu.
* org-exp.el (org-export-remove-special-table-lines): Remove bad
slow regexp match.
2009-10-01 Carsten Dominik <carsten.dominik@gmail.com>
* org-latex.el (org-export-latex-preprocess): Do not protect in
the LaTeX header.
* org-src.el (org-edit-src-save): Save window setup while saving.
(org-edit-src-code): Use new buffer name construction scheme.
2009-10-01 Carsten Dominik <carsten.dominik@gmail.com>
* org-agenda.el (org-agenda-entry-text-exclude-regexps): New
variable.
(org-agenda-entry-text-cleanup-hook): New hook.
(org-agenda-get-some-entry-text): Remove matches of
`org-agenda-entry-text-exclude-regexps' and run the hook
`org-agenda-entry-text-cleanup-hook'.
* org.el (org-offer-links-in-entry): New argument ZERO to
implement a link with index zero.
(org-cycle-show-empty-lines): Not keep empty line under header
hidden.
(org-iswitchb-completing-read): Bind `switchb-use-virtual-buffers'
to nil for special completion.
(org-store-link): Don't error before the first heading.
* org-agenda.el (org-agenda-open-link): Pass the prefix to
`org-offer-links-in-entry'.
2009-10-01 Carsten Dominik <carsten.dominik@gmail.com>
* org-agenda.el (org-agenda-quit): Provide the window argument for
`window-dedicated-p', Emacs 22 needs it.
(org-format-agenda-item): If the category is a link, arrange for
invisible text to replaced with spaces.
(org-compile-prefix-format): Add the extra space.
(org-prefix-category-length): New variable.
* org-exp.el (org-export-cleanup-toc-line): Remove footnote
references from TOC lines.
* org.el (org-selected-window): New variable.
* org-table.el (org-table-edit-formulas): Remember the selected
window.
(org-table-fedit-finish, org-table-fedit-abort): Select the window
that was originally selected.
* org-exp.el (org-export-preprocess-apply-macros): Scan the
expansion of a macro for more macro definitions.
* org-agenda.el (org-agenda-dim-blocked-tasks): Make sure the
invisibility overlay starts on the newline.
author | Carsten Dominik <dominik@science.uva.nl> |
---|---|
date | Thu, 01 Oct 2009 07:59:53 +0000 |
parents | 68e6b02ce6b6 |
children | f039ef236594 |
line wrap: on
line source
#! /bin/sh # RCS to ChangeLog generator # Copyright (C) 1992, 1993, 1994, 1995, 1996, 1997, 1998, 2001, 2002, 2003, # 2004, 2005, 2006, 2007, 2008, 2009 # Free Software Foundation, Inc. # Author: Paul Eggert <eggert@twinsun.com> # This program is free software: you can redistribute it and/or modify # it under the terms of the GNU General Public License as published by # the Free Software Foundation, either version 3 of the License, or # (at your option) any later version. # This program is distributed in the hope that it will be useful, # but WITHOUT ANY WARRANTY; without even the implied warranty of # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the # GNU General Public License for more details. # You should have received a copy of the GNU General Public License # along with this program. If not, see <http://www.gnu.org/licenses/>. Copyright='Copyright (C) 2009 Free Software Foundation, Inc. This program comes with NO WARRANTY, to the extent permitted by law. You may redistribute copies of this program under the terms of the GNU General Public License. For more information about these matters, see the files named COPYING. Author: Paul Eggert <eggert@twinsun.com>' Help=' Generate ChangeLog entries from RCS files (perhaps in a CVS repository) and the ChangeLog file (if any). An RCS file typically has a name ending in ",v", and represents the entire history of a file that is under revision control. The ChangeLog file logs entries for changes, in reverse chronological order. Generate entries for changes entered into RCS (or CVS) more recently than the newest existing entry in the ChangeLog file. You can then edit these entries by hand, and prepend them to the ChangeLog file. Output the resulting ChangeLog entries to standard output. Each entry looks something like this: 2004-04-17 Paul Eggert <eggert@gnu.org> * rcs2log (Help): Clarify wording of the usage message. Problem reported by Alan Mackenzie in <http://mail.gnu.org/archive/html/bug-gnu-emacs/2004-04/msg00188.html>. ChangeLog entries contain the current date, full name, email address including hostname, the name of the affected file, and commentary. RCS and CVS logs lack full names and email addresses, so they are inferred from login names using a heuristic that can be overridden via the -u option. Ignore log entries that start with "#". Clump together log entries that start with "{topic} ", where "topic" contains neither white space nor "}". If no FILE is specified, use all files under the working directory that are maintained under version control. Options: -c FILE Output ChangeLog entries for FILE (default ChangeLog). -h HOSTNAME Use HOSTNAME in change log entries (default current host). -i INDENT Indent change log lines by INDENT spaces (default 8). -l LENGTH Try to limit log lines to LENGTH characters (default 79). -L FILE Use FILE (same format as "rlog") for source of logs. -R If no FILEs are given and RCS is used, recurse through working directory. -r OPTION Pass OPTION to subsidiary command (either "rlog" or "cvs -q log"). -t TABWIDTH Tab stops are every TABWIDTH characters (default 8). -u "LOGIN<tab>FULLNAME<tab>EMAILADDR" LOGIN has FULLNAME and EMAILADDR. -v Append RCS revision to file names in log lines. --help Output help. --version Output version number. Report bugs to <bug-gnu-emacs@gnu.org>.' Id='$Id$' # Use the traditional C locale. LANG=C LANGUAGE=C LC_ALL=C LC_COLLATE=C LC_CTYPE=C LC_MESSAGES=C LC_NUMERIC=C LC_TIME=C export LANG LANGUAGE LC_ALL LC_COLLATE LC_CTYPE LC_MESSAGES LC_NUMERIC LC_TIME # These variables each contain a single ASCII character. # Unfortunately, there's no portable way of writing these characters # in older Unix implementations, other than putting them directly into # this text file. SOH='' # SOH, octal code 001 tab=' ' nl=' ' # Parse options. # defaults AWK=${AWK-awk} TMPDIR=${TMPDIR-/tmp} changelog=ChangeLog # change log file name datearg= # rlog date option hostname= # name of local host (if empty, will deduce it later) indent=8 # indent of log line length=79 # suggested max width of log line logins= # login names for people we know fullnames and mailaddrs of loginFullnameMailaddrs= # login<tab>fullname<tab>mailaddr triplets logTZ= # time zone for log dates (if empty, use local time) recursive= # t if we want recursive rlog revision= # t if we want revision numbers rlog_options= # options to pass to rlog rlogfile= # log file to read from tabwidth=8 # width of horizontal tab while : do case $1 in -c) changelog=${2?}; shift;; -i) indent=${2?}; shift;; -h) hostname=${2?}; shift;; -l) length=${2?}; shift;; -L) rlogfile=${2?}; shift;; -[nu]) # -n is obsolescent; it is replaced by -u. case $1 in -n) case ${2?}${3?}${4?} in *"$tab"* | *"$nl"*) echo >&2 "$0: -n '$2' '$3' '$4': tabs, newlines not allowed" exit 1;; esac login=$2 lfm=$2$tab$3$tab$4 shift; shift; shift;; -u) # If $2 is not tab-separated, use colon for separator. case ${2?} in *"$nl"*) echo >&2 "$0: -u '$2': newlines not allowed" exit 1;; *"$tab"*) t=$tab;; *) t=':';; esac case $2 in *"$t"*"$t"*"$t"*) echo >&2 "$0: -u '$2': too many fields" exit 1;; *"$t"*"$t"*) uf="[^$t]*$t" # An unselected field, followed by a separator. sf="\\([^$t]*\\)" # The selected field. login=`expr "X$2" : "X$sf"` lfm="$login$tab"` expr "X$2" : "$uf$sf" `"$tab"` expr "X$2" : "$uf$uf$sf" `;; *) echo >&2 "$0: -u '$2': not enough fields" exit 1;; esac shift;; esac case $logins in '') logins=$login;; ?*) logins=$logins$nl$login;; esac case $loginFullnameMailaddrs in '') loginFullnameMailaddrs=$lfm;; ?*) loginFullnameMailaddrs=$loginFullnameMailaddrs$nl$lfm;; esac;; -r) case $rlog_options in '') rlog_options=${2?};; ?*) rlog_options=$rlog_options$nl${2?};; esac shift;; -R) recursive=t;; -t) tabwidth=${2?}; shift;; -v) revision=t;; --version) set $Id rcs2logVersion=$3 echo >&2 "rcs2log (GNU Emacs) $rcs2logVersion$nl$Copyright" exit 0;; -*) echo >&2 "Usage: $0 [OPTION]... [FILE ...]$nl$Help" case $1 in --help) exit 0;; *) exit 1;; esac;; *) break;; esac shift done month_data=' m[0]="Jan"; m[1]="Feb"; m[2]="Mar" m[3]="Apr"; m[4]="May"; m[5]="Jun" m[6]="Jul"; m[7]="Aug"; m[8]="Sep" m[9]="Oct"; m[10]="Nov"; m[11]="Dec" ' logdir=$TMPDIR/rcs2log$$ llogout=$logdir/l trap exit 1 2 13 15 trap "rm -fr $logdir 2>/dev/null" 0 (umask 077 && exec mkdir $logdir) || exit # If no rlog-format log file is given, generate one into $rlogfile. case $rlogfile in '') rlogfile=$logdir/r # If no rlog options are given, # log the revisions checked in since the first ChangeLog entry. # Since ChangeLog is only by date, some of these revisions may be # duplicates of what's already in ChangeLog; it's the user's # responsibility to remove them. case $rlog_options in '') if test -s "$changelog" then e=' /^[0-9]+-[0-9][0-9]-[0-9][0-9]/{ # ISO 8601 date print $1 exit } /^... ... [ 0-9][0-9] [ 0-9][0-9]:[0-9][0-9]:[0-9][0-9] [0-9]+ /{ # old-fashioned date and time (Emacs 19.31 and earlier) '"$month_data"' year = $5 for (i=0; i<=11; i++) if (m[i] == $2) break dd = $3 printf "%d-%02d-%02d\n", year, i+1, dd exit } ' d=`$AWK "$e" <"$changelog"` || exit case $d in ?*) datearg="-d>$d";; esac fi;; esac # Use TZ specified by ChangeLog local variable, if any. if test -s "$changelog" then extractTZ=' /^.*change-log-time-zone-rule['"$tab"' ]*:['"$tab"' ]*"\([^"]*\)".*/{ s//\1/; p; q } /^.*change-log-time-zone-rule['"$tab"' ]*:['"$tab"' ]*t.*/{ s//UTC0/; p; q } ' logTZ=`tail "$changelog" | sed -n "$extractTZ"` case $logTZ in ?*) TZ=$logTZ; export TZ;; esac fi # If CVS is in use, examine its repository, not the normal RCS files. if test ! -f CVS/Repository then rlog=rlog repository= else rlog='cvs -q log' repository=`sed 1q <CVS/Repository` || exit test ! -f CVS/Root || CVSROOT=`cat <CVS/Root` || exit pository= case $CVSROOT in /* | :fork:* | :local:*) ;; */*) # remote repository pository=`expr "X$CVSROOT" : '[^/]*\(.*\)'`;; esac case $pository in '') # local repository case $repository in /*) ;; *) repository=${CVSROOT?}/$repository case $repository in :fork:* | :local:*) repository=`expr "$repository" : ':[^:]*:\(.*\)'`;; esac;; esac if test ! -d "$repository" then echo >&2 "$0: $repository: bad repository (see CVS/Repository)" exit 1 fi pository=$repository;; esac # Ensure that $pository ends in exactly one slash. while : do case $pository in *//) pository=`expr "X$pository" : 'X\(.*\)/'`;; */) break;; *) pository=$pository/; break;; esac done # If no rlog options are given, and if we are in a tagged CVS branch, # log only the changes in that branch. case $rlog_options in '') if test -f CVS/Tag then CVSTAG=`cat <CVS/Tag` || exit case $CVSTAG in T?*) rlog_options=-r`expr "$CVSTAG" : 'T\(.*\)'`;; *) echo >&2 "$0: invalid CVS/Tag"; exit 1;; esac fi;; esac fi # Use $rlog's -zLT option, if $rlog supports it. case `$rlog -zLT 2>&1` in *' option'*) ;; *) case $rlog_options in '') rlog_options=-zLT;; ?*) rlog_options=-zLT$nl$rlog_options;; esac;; esac # With no arguments, examine all files under the RCS directory. case $# in 0) case $repository in '') oldIFS=$IFS IFS=$nl case $recursive in t) RCSdirs=`find . -name RCS -type d -print` filesFromRCSfiles='s|,v$||; s|/RCS/|/|; s|^\./||' files=` { case $RCSdirs in ?*) find $RCSdirs \ -type f \ ! -name '*_' \ ! -name ',*,' \ ! -name '.*_' \ ! -name .rcsfreeze.log \ ! -name .rcsfreeze.ver \ -print;; esac find . -name '*,v' -print } | sort -u | sed "$filesFromRCSfiles" `;; *) files= for file in RCS/.* RCS/* .*,v *,v do case $file in RCS/. | RCS/.. | RCS/,*, | RCS/*_) continue;; RCS/.rcsfreeze.log | RCS/.rcsfreeze.ver) continue;; RCS/.\* | RCS/\* | .\*,v | \*,v) test -f "$file" || continue;; RCS/*,v | RCS/.*,v) ;; RCS/* | RCS/.*) test -f "$file" || continue;; esac case $files in '') files=$file;; ?*) files=$files$nl$file;; esac done case $files in '') exit 0;; esac;; esac set x $files shift IFS=$oldIFS;; esac;; esac case $datearg in ?*) $rlog $rlog_options "$datearg" ${1+"$@"} >$rlogfile;; '') $rlog $rlog_options ${1+"$@"} >$rlogfile;; esac || exit;; esac # Prefer the POSIX-style -k options, since POSIX 1003.1-2001 prohibits # support for the traditional-style +M -N options. SORT_K_OPTIONS='-k 3,4r -k 5 -k 1' sort $SORT_K_OPTIONS </dev/null 2>/dev/null || SORT_K_OPTIONS='+2 -4r +4 +0' # Get the full name of each author the logs mention, and set initialize_fullname # to awk code that initializes the `fullname' awk associative array. # Warning: foreign authors (i.e. not known in the passwd file) are mishandled; # you have to fix the resulting output by hand. initialize_fullname= initialize_mailaddr= case $loginFullnameMailaddrs in ?*) case $loginFullnameMailaddrs in *\"* | *\\*) sed 's/["\\]/\\&/g' >$llogout <<EOF || exit $loginFullnameMailaddrs EOF loginFullnameMailaddrs=`cat $llogout`;; esac oldIFS=$IFS IFS=$nl for loginFullnameMailaddr in $loginFullnameMailaddrs do IFS=$tab set x $loginFullnameMailaddr login=$2 fullname=$3 mailaddr=$4 initialize_fullname="$initialize_fullname fullname[\"$login\"] = \"$fullname\"" initialize_mailaddr="$initialize_mailaddr mailaddr[\"$login\"] = \"$mailaddr\"" done IFS=$oldIFS;; esac case $logins in ?*) sort -u -o $llogout <<EOF $logins EOF ;; '') : ;; esac >$llogout || exit output_authors='/^date: / { if ($2 ~ /^[0-9]*[-\/][0-9][0-9][-\/][0-9][0-9]$/ && $3 ~ /^[0-9][0-9]:[0-9][0-9]:[0-9][0-9][-+0-9:]*;$/ && $4 == "author:" && $5 ~ /^[^;]*;$/) { print substr($5, 1, length($5)-1) } }' authors=` $AWK "$output_authors" <"$rlogfile" | sort -u | comm -23 - $llogout ` case $authors in ?*) cat >$llogout <<EOF || exit $authors EOF initialize_author_script='s/["\\]/\\&/g; s/.*/author[\"&\"] = 1/' initialize_author=`sed -e "$initialize_author_script" <$llogout` awkscript=' BEGIN { alphabet = "abcdefghijklmnopqrstuvwxyz" ALPHABET = "ABCDEFGHIJKLMNOPQRSTUVWXYZ" '"$initialize_author"' } { if (author[$1]) { fullname = $5 if (fullname ~ /[0-9]+-[^(]*\([0-9]+\)$/) { # Remove the junk from fullnames like "0000-Admin(0000)". fullname = substr(fullname, index(fullname, "-") + 1) fullname = substr(fullname, 1, index(fullname, "(") - 1) } if (fullname ~ /,[^ ]/) { # Some sites put comma-separated junk after the fullname. # Remove it, but leave "Bill Gates, Jr" alone. fullname = substr(fullname, 1, index(fullname, ",") - 1) } abbr = index(fullname, "&") if (abbr) { a = substr($1, 1, 1) A = a i = index(alphabet, a) if (i) A = substr(ALPHABET, i, 1) fullname = substr(fullname, 1, abbr-1) A substr($1, 2) substr(fullname, abbr+1) } # Quote quotes and backslashes properly in full names. # Do not use gsub; traditional awk lacks it. quoted = "" rest = fullname for (;;) { p = index(rest, "\\") q = index(rest, "\"") if (p) { if (q && q<p) p = q } else { if (!q) break p = q } quoted = quoted substr(rest, 1, p-1) "\\" substr(rest, p, 1) rest = substr(rest, p+1) } printf "fullname[\"%s\"] = \"%s%s\"\n", $1, quoted, rest author[$1] = 0 } } ' initialize_fullname=` { (getent passwd $authors) || ( cat /etc/passwd for author in $authors do NIS_PATH= nismatch $author passwd.org_dir done ypmatch $authors passwd ) } 2>/dev/null | $AWK -F: "$awkscript" `$initialize_fullname;; esac # Function to print a single log line. # We don't use awk functions, to stay compatible with old awk versions. # `Log' is the log message. # `files' contains the affected files. printlogline='{ # Following the GNU coding standards, rewrite # * file: (function): comment # to # * file (function): comment if (Log ~ /^\([^)]*\):[\t\n ]/) { i = index(Log, ")") filefunc = substr(Log, 1, i) while ((j = index(filefunc, "\n"))) { files = files " " substr(filefunc, 1, j-1) filefunc = substr(filefunc, j+1) } files = files " " filefunc Log = substr(Log, i+3) } # If "label: comment" is too long, break the line after the ":". sep = " " i = index(Log, "\n") if ('"$length"' <= '"$indent"' + 1 + length(files) + i) sep = "\n" indent_string # Print the label. printf "%s*%s:", indent_string, files # Print each line of the log. while (i) { logline = substr(Log, 1, i-1) if (logline ~ /[^'"$tab"' ]/) { printf "%s%s\n", sep, logline } else { print "" } sep = indent_string Log = substr(Log, i+1) i = index(Log, "\n") } }' # Pattern to match the `revision' line of rlog output. rlog_revision_pattern='^revision [0-9]+\.[0-9]+(\.[0-9]+\.[0-9]+)*(['"$tab"' ]+locked by: [^'"$tab"' $,.0-9:;@]*[^'"$tab"' $,:;@][^'"$tab"' $,.0-9:;@]*;)?['"$tab"' ]*$' case $hostname in '') hostname=`( hostname || uname -n || uuname -l || cat /etc/whoami ) 2>/dev/null` || { echo >&2 "$0: cannot deduce hostname" exit 1 } case $hostname in *.*) ;; *) domainname=`(domainname) 2>/dev/null` && case $domainname in *.*) hostname=$hostname.$domainname;; esac;; esac;; esac # Process the rlog output, generating ChangeLog style entries. # First, reformat the rlog output so that each line contains one log entry. # Transliterate \n to SOH so that multiline entries fit on a single line. # Discard irrelevant rlog output. $AWK ' BEGIN { pository = "'"$pository"'" SOH="'"$SOH"'" } /^RCS file: / { if (pository != "") { filename = substr($0, 11) if (substr(filename, 1, length(pository)) == pository) { filename = substr(filename, length(pository) + 1) } if (filename ~ /,v$/) { filename = substr(filename, 1, length(filename) - 2) } if (filename ~ /(^|\/)Attic\/[^\/]*$/) { i = length(filename) while (substr(filename, i, 1) != "/") i-- filename = substr(filename, 1, i - 6) substr(filename, i + 1) } } rev = "?" } /^Working file: / { if (repository == "") filename = substr($0, 15) } /'"$rlog_revision_pattern"'/, /^(-----------*|===========*)$/ { line = $0 if (line ~ /'"$rlog_revision_pattern"'/) { rev = $2 next } if (line ~ /^date: [0-9][- +\/0-9:]*;/) { date = $2 if (date ~ /\//) { # This is a traditional RCS format date YYYY/MM/DD. # Replace "/"s with "-"s to get ISO format. newdate = "" while ((i = index(date, "/")) != 0) { newdate = newdate substr(date, 1, i-1) "-" date = substr(date, i+1) } date = newdate date } time = substr($3, 1, length($3) - 1) author = substr($5, 1, length($5)-1) printf "%s%s%s%s%s%s%s%s%s%s", filename, SOH, rev, SOH, date, SOH, time, SOH, author, SOH rev = "?" next } if (line ~ /^branches: /) { next } if (line ~ /^(-----------*|===========*)$/) { print ""; next } if (line == "Initial revision" || line ~ /^file .+ was initially added on branch .+\.$/) { line = "New file." } printf "%s%s", line, SOH } ' <"$rlogfile" | # Now each line is of the form # FILENAME@REVISION@YYYY-MM-DD@HH:MM:SS[+-TIMEZONE]@AUTHOR@LOG # where @ stands for an SOH (octal code 001), # and each line of LOG is terminated by SOH instead of \n. # Sort the log entries, first by date+time (in reverse order), # then by author, then by log entry, and finally by file name and revision # (just in case). sort -t"$SOH" $SORT_K_OPTIONS | # Finally, reformat the sorted log entries. $AWK -F"$SOH" ' BEGIN { logTZ = "'"$logTZ"'" revision = "'"$revision"'" # Initialize the fullname and mailaddr associative arrays. '"$initialize_fullname"' '"$initialize_mailaddr"' # Initialize indent string. indent_string = "" i = '"$indent"' if (0 < '"$tabwidth"') for (; '"$tabwidth"' <= i; i -= '"$tabwidth"') indent_string = indent_string "\t" while (1 <= i--) indent_string = indent_string " " } { newlog = "" for (i = 6; i < NF; i++) newlog = newlog $i "\n" # Ignore log entries prefixed by "#". if (newlog ~ /^#/) { next } if (Log != newlog || date != $3 || author != $5) { # The previous log and this log differ. # Print the old log. if (date != "") '"$printlogline"' # Logs that begin with "{clumpname} " should be grouped together, # and the clumpname should be removed. # Extract the new clumpname from the log header, # and use it to decide whether to output a blank line. newclumpname = "" sep = "\n" if (date == "") sep = "" if (newlog ~ /^\{[^'"$tab"' }]*}['"$tab"' ]/) { i = index(newlog, "}") newclumpname = substr(newlog, 1, i) while (substr(newlog, i+1) ~ /^['"$tab"' ]/) i++ newlog = substr(newlog, i+1) if (clumpname == newclumpname && date == $3 && author == $5) sep = "" } printf sep clumpname = newclumpname # Get ready for the next log. Log = newlog if (files != "") for (i in filesknown) filesknown[i] = 0 files = "" } if (date != $3 || author != $5) { # The previous date+author and this date+author differ. # Print the new one. date = $3 time = $4 author = $5 zone = "" if (logTZ && ((i = index(time, "-")) || (i = index(time, "+")))) zone = " " substr(time, i) # Print "date[ timezone] fullname <email address>". # Get fullname and email address from associative arrays; # default to author and author@hostname if not in arrays. if (fullname[author]) auth = fullname[author] else auth = author printf "%s%s %s ", date, zone, auth if (mailaddr[author]) printf "<%s>\n\n", mailaddr[author] else printf "<%s@%s>\n\n", author, "'"$hostname"'" } if (! filesknown[$1]) { filesknown[$1] = 1 if (files == "") files = " " $1 else files = files ", " $1 if (revision && $2 != "?") files = files " " $2 } } END { # Print the last log. if (date != "") { '"$printlogline"' printf "\n" } } ' && # Exit successfully. exec rm -fr $logdir # Local Variables: # tab-width:4 # End: # arch-tag: cea067bd-a552-4254-ba17-078208933073